%module LIMAL

/*
  for limal libraries use %import _not_ %include
  %include happens in limal (core) library
*/

%{
#include <limal/ByteBuffer.hpp>
%}

namespace limal
{
    class ByteBuffer
    {
    public:
        ByteBuffer();
        ByteBuffer(const char *str);
        ByteBuffer(const char *ptr, size_t len);
        ByteBuffer(const ByteBuffer &buf);
        ~ByteBuffer();
        void        clear();
        bool        empty() const;
        size_t      size() const;
        const char* data() const;
        char        at(size_t pos) const;
        void        append(const char *ptr, size_t len);
        void        append(char c);
    };
}

%template(StringArray) blocxx::Array<blocxx::String>;
%template(StringList)  blocxx::List<blocxx::String>;
%template(StringMap)  blocxx::Map<blocxx::String, blocxx::String>;
%template(Int32List)   blocxx::List<blocxx::Int32>;
