%{
#include <inttypes.h>
#include <blocxx/Types.hpp>
%}

%apply long {time_t};
%apply unsigned long { size_t };

/**********************************************
 * [U]Int32
 **********************************************/

/* Input typemaps */

%typemap(in) blocxx::Int32  "$1 = ($1_ltype) SvIV($input);";
%typemap(in) blocxx::UInt32 "$1 = ($1_ltype) SvUV($input);";

/* Const primitive references.  Passed by value */

%typemap(in) const blocxx::Int32 &(blocxx::Int32 temp)
        "temp = ($*1_ltype) SvIV($input);
        $1 = &temp;";

%typemap(in) const blocxx::UInt32 &(blocxx::UInt32 temp)
        "temp = ($*1_ltype) SvUV($input);
         $1 = &temp;";

/* Typemap for output values */
%typemap(out) const blocxx::Int32, blocxx::Int32
    "ST(argvi) = sv_newmortal();
     sv_setiv(ST(argvi++), (IV) $1);";

%typemap(out) const blocxx::UInt32, blocxx::UInt32
    "ST(argvi) = sv_newmortal();
     sv_setuv(ST(argvi++), (UV) $1);";

/* References to primitive types.  Return by value */

%typemap(out) const blocxx::Int32 &, blocxx::Int32 &
      "ST(argvi) = sv_newmortal();
       sv_setiv(ST(argvi++), (IV) *($1));";

%typemap(out) const blocxx::UInt32 &, blocxx::UInt32 &
      "ST(argvi) = sv_newmortal();
       sv_setuv(ST(argvi++), (UV) *($1));";


/* Variable input */

%typemap(varin) blocxx::Int32  "$1 = ($1_ltype) SvIV($input);";
%typemap(varin) blocxx::UInt32 "$1 = ($1_ltype) SvUV($input);";

/* Const primitive references.  Passed by value */

%typemap(varin) const blocxx::Int32& (blocxx::Int32 temp)
        "temp = ($*1_ltype) SvIV($input);
         $1 = &temp;";

%typemap(varin) const blocxx::UInt32& (blocxx::UInt32 temp)
        "temp = ($*1_ltype) SvUV($input);
         $1 = &temp;";

/* --- Typemaps for variable output --- */

%typemap(varout) blocxx::Int32  "sv_setiv($result, (IV) $1);";
%typemap(varout) blocxx::UInt32 "sv_setuv($result, (UV) $1);";

%typecheck(SWIG_TYPECHECK_INTEGER) 
         blocxx::Int32, blocxx::UInt32
{
  $1 = SvIOK($input) ? 1 : 0;
}


/**********************************************
 * [U]Int64
 **********************************************/

/* Input typemaps */

%typemap(in) blocxx::Int64  "$1 = ($1_ltype) strtoll(SvPV($input, PL_na), 0, 0);";
%typemap(in) blocxx::UInt64 "$1 = ($1_ltype) strtoull(SvPV($input, PL_na), 0, 0);";

%typemap(in) const blocxx::Int64 &(blocxx::Int64 temp) {
        temp = ($1_ltype) strtoll(SvPV($input, PL_na), 0, 0);
        $1 = &temp;";
}

%typemap(in) const blocxx::UInt64 &(blocxx::UInt64 temp) {
        temp = ($1_ltype) strtoull(SvPV($input, PL_na), 0, 0);
        $1 = &temp;
}

%typemap(varin) blocxx::Int64  "$1 = ($1_ltype) strtoll(SvPV($input, PL_na), 0, 0);";
%typemap(varin) blocxx::UInt64 "$1 = ($1_ltype) strtoull(SvPV($input, PL_na), 0, 0);";

%typemap(varin) const blocxx::Int64 &(blocxx::Int64 temp) {
        temp = ($1_ltype) strtoll(SvPV($input, PL_na), 0, 0);
        $1 = &temp;";
}

%typemap(varin) const blocxx::UInt64 &(blocxx::UInt64 temp) {
        temp = ($1_ltype) strtoull(SvPV($input, PL_na), 0, 0);
        $1 = &temp;
}


/* Output typemaps */

%typemap(out) const blocxx::Int64, blocxx::Int64 {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }
    snprintf(temp, sizeof(temp), "%"PRId64, $1);
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(out) const blocxx::UInt64, blocxx::UInt64 {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }
    snprintf(temp, sizeof(temp), "%"PRIu64, $1);
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(out) const blocxx::Int64 &, blocxx::Int64 & {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }
    snprintf(temp, sizeof(temp), "%"PRId64, *($1));
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(out) const blocxx::UInt64 &, blocxx::UInt64 & {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }
    snprintf(temp, sizeof(temp), "%"PRIu64, *($1));
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(varout) blocxx::Int64 {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }
    snprintf(temp, sizeof(temp), "%"PRId64, $1);
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(varout) blocxx::UInt64 {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }

    snprintf(temp, sizeof(temp), "%"PRIu64, $1);
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(varout) const blocxx::Int64 & {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }
    snprintf(temp, sizeof(temp), "%"PRId64, *($1));
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

%typemap(varout) const blocxx::UInt64 & {
    char temp[25];
    if (argvi >= items) {
        EXTEND(sp,1);
    }

    snprintf(temp, sizeof(temp), "%"PRIu64, *($1));
    $result = sv_newmortal();
    sv_setpv($result,temp);
    argvi++;
}

/* check typemaps */

%typecheck(SWIG_TYPECHECK_INTEGER)
    blocxx::Int64, blocxx::UInt64
{
  $1 = SvIOK($input) ? 1 : 0;
}
